## grandorgue 3.13.1

=== CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2023 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later
# (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

cmake_minimum_required(VERSION 3.10)

# Project version numbers
if(NOT DEFINED VERSION)
  file(STRINGS "version.txt" VERSION)
  if(NOT VERSION)
    message(FATAL_ERROR "Unable to get version from version.txt")
  endif()
endif()

project(
  GrandOrgue
  VERSION "${VERSION}"
  DESCRIPTION "GrandOrgue - free pipe organ simulator"
  LANGUAGES CXX C
  HOMEPAGE_URL "https://github.com/GrandOrgue/grandorgue"
)
set(NUM_VERSION "${PROJECT_VERSION}")
string(REPLACE "." "," NUM_WIN_VERSION ${NUM_VERSION})

if(NOT DEFINED BUILD_VERSION)
  set(BUILD_VERSION "0.local")
elseif(NOT BUILD_VERSION)
  set(BUILD_VERSION "0.0")
endif()

set(FULL_VERSION "${PROJECT_VERSION}-${BUILD_VERSION}")

# Build configuration options
option(RTAUDIO_USE_CORE       "Enable RtAudio support for Core Audio (Rt and PortAudio - OS X only)" ON)
option(RTAUDIO_USE_JACK       "Enable RtAudio support for Jack (Rt and PortAudio)" ON)
option(RTAUDIO_USE_OSS        "Enable RtAudio support for OSS (Rt and PortAudio - Linux only)" OFF)
option(RTAUDIO_USE_ALSA       "Enable RtAudio support for ALSA (Rt and PortAudio - Linux only)" ON)
option(RTAUDIO_USE_DSOUND     "Enable RtAudio support for DirectSound (Rt and PortAudio - Windows only)" ON)
option(RTAUDIO_USE_ASIO       "Enable RtAudio support for ASIO (Rt and PortAudio - Windows only)" ON)
option(RTAUDIO_USE_WMME       "Enable RtAudio support for WMME (PortAudio only - Windows only)" ON)
option(RTAUDIO_USE_WDMKS      "Enable RtAudio support for WDMKS (PortAudio only - Windows only)" ON)
option(RTAUDIO_USE_WASAPI     "Enable RtAudio support for WASAPI (PortAudio only - Windows only)" ON)
option(RTMIDI_USE_CORE        "Enable RtMidi support for Core Audio (OS X only)" ON)
option(RTMIDI_USE_JACK        "Enable RtMidi support for Jack" ON)
option(RTMIDI_USE_ALSA        "Enable RtMidi support for ALSA (Linux only)" ON)
option(RTMIDI_USE_MM          "Enable RtMidi support for MM (Windows only)" ON)
option(USE_INTERNAL_RTAUDIO   "Use builtin RtAudio/RtMidi sources" ON)
option(INSTALL_DEMO           "Install demo sampleset" ON)
option(USE_INTERNAL_PORTAUDIO "Use builtin PortAudio sources" ON)
option(USE_INTERNAL_ZITACONVOLVER "Use builtin Zita Convolver sources" ON)
option(GO_USE_JACK	      "Use native Jack output" ON)
if (WIN32 OR APPLE)
   option(INSTALL_DEPEND      "Copy dependencies (wxWidgets libraries and Translations) on installation" ON)
else ()
   option(INSTALL_DEPEND      "Copy dependencies (wxWidgets libraries and Translations) on installation" OFF)
endif ()
option(GO_SEPARATE_LINUX_PACKAGES "Generate separate linux packages for resources and demo" OFF)
option(USE_BUILD_SYSTEM_LIBDIR "Use build system (distro-specific) libdir (Linux only)" OFF)

# only use options supported by the compiler
include(CheckIncludeFileCXX)
include(CheckFunctionExists)
include(FindPkgConfig)
include(${CMAKE_SOURCE_DIR}/cmake/AddOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/AddCXXOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/FindTools.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/BuildLibrary.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/BuildExecutable.cmake)

add_cxx_option(-std=c++11)

IF (APPLE)
  set(BININSTDIR "${PROJECT_NAME}.app/Contents/MacOS")
  SET(LIBINSTDIR "${PROJECT_NAME}.app/Contents/MacOS")
  SET(RESOURCEINSTDIR "${PROJECT_NAME}.app/Contents/Resources")
  SET(RPATH_PREFIX "@executable_path")
ELSE()
  set(BININSTDIR "bin")
  IF (WIN32)
    SET(LIBINSTDIR "bin")
  ELSEIF (USE_BUILD_SYSTEM_LIBDIR)
    # See https://cmake.org/cmake/help/latest/module/GNUInstallDirs.html for
    # the purpose of this module
    include(GNUInstallDirs)
    SET(LIBINSTDIR "${CMAKE_INSTALL_LIBDIR}" CACHE STRING "library directory")
  ELSE ()
    SET(LIBINSTDIR "lib" CACHE STRING "library directory")
  ENDIF ()
  SET(RESOURCEINSTDIR "share/${PROJECT_NAME}")
  SET(RPATH_PREFIX "$ORIGIN")
ENDIF()
SET(BINDIR "${CMAKE_BINARY_DIR}/${BININSTDIR}")
SET(LIBDIR "${CMAKE_BINARY_DIR}/${LIBINSTDIR}")
SET(RESOURCEDIR "${CMAKE_BINARY_DIR}/${RESOURCEINSTDIR}")

if (APPLE AND INSTALL_DEPEND STREQUAL "ON")
  set(OBJECT_FIXUP_REQUIRED "ON")
else()
  set(OBJECT_FIXUP_REQUIRED "OFF")
endif()

file(RELATIVE_PATH RPATH "${BINDIR}" "${LIBDIR}")
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_INSTALL_RPATH "${RPATH_PREFIX}/${RPATH}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

# setup compiler flags for debug vs release compiles
add_option(-Wall)
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_option(-g3)
else()
  add_option(-O3)
  add_option(-g)
  add_definitions(-DNDEBUG)
  add_option(-fomit-frame-pointer)
  add_option(-funroll-loops)
  add_option(-ffast-math)
endif ()

if (RTAUDIO_USE_JACK OR RTMIDI_USE_JACK OR GO_USE_JACK)
  pkg_check_modules(JACK REQUIRED IMPORTED_TARGET jack)
endif()

# Add ASIO variable
if(WIN32 AND RTAUDIO_USE_ASIO)
  add_definitions(-DASIO_INCLUDED)
endif()

if(RTAUDIO_USE_ASIO AND NOT ASIO_SDK_DIR)
  set(ASIO_SDK_DIR "${CMAKE_SOURCE_DIR}/ext/rt/asio")
endif()

# include RtAudio
if (USE_INTERNAL_RTAUDIO)
  if(NOT RTAUDIO_SRC_DIR)
    set(RTAUDIO_SRC_DIR "${CMAKE_SOURCE_DIR}/submodules/RtAudio")
    if(NOT EXISTS "${RTAUDIO_SRC_DIR}/RtAudio.h")
      message(
        FATAL_ERROR 
        "${RTAUDIO_SRC_DIR}/RtAudio.h file does not exist."
        "Possible the RtAudio submodule has not been updated."
        "Try to execute 'git submodule update --init --recursive' in the source directory"
      )
    endif()
  endif()
  if(NOT RTMIDI_SRC_DIR)
    set(RTMIDI_SRC_DIR "${CMAKE_SOURCE_DIR}/submodules/RtMidi")
    if(NOT EXISTS "${RTMIDI_SRC_DIR}/RtMidi.h")
      message(
        FATAL_ERROR 
        "${RTMIDI_SRC_DIR}/RtMidi.h file does not exist."
        "Possible the RtMidi submodule has not been updated."
        "Try to execute 'git submodule update --init --recursive' in the source directory"
      )
    endif()
  endif()
  add_subdirectory(src/rt)
  set(RT_LIBRARIES RtAudio RtMidi)
  set(RT_INCLUDE_DIRS ${RTMIDI_SRC_DIR} ${RTAUDIO_SRC_DIR})
else()
  pkg_check_modules(RTAUDIO REQUIRED rtaudio)
  pkg_check_modules(RTMIDI REQUIRED rtmidi)
  set(RT_LIBRARIES ${RTAUDIO_LIBRARIES} ${RTMIDI_LIBRARIES})
  set(RT_INCLUDE_DIRS ${RTMIDI_INCLUDE_DIRS} ${RTAUDIO_INCLUDE_DIRS})
endif()

# include portaudio
if (USE_INTERNAL_PORTAUDIO)
  set(PORTAUDIO_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/submodules/PortAudio/include)
  add_subdirectory(src/portaudio)
  set(PORTAUDIO_LIBRARIES PortAudio)
else()
  pkg_check_modules(PORTAUDIO REQUIRED portaudio-2.0)
endif()

# include zitaconvolver
if (USE_INTERNAL_ZITACONVOLVER)
  set(ZITACONVOLVER_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/submodules/ZitaConvolver/source)
  set(ZITACONVOLVER_LIBRARIES "")
else()
  set(ZITACONVOLVER_INCLUDE_DIRS "")
  set(ZITACONVOLVER_LIBRARIES zita-convolver)
endif()

# include FFTW
pkg_check_modules(FFTW REQUIRED fftw3f)

pkg_check_modules(ZLIB REQUIRED zlib)

pkg_check_modules(WAVPACK REQUIRED wavpack)

find_package(wxWidgets REQUIRED base)
message(STATUS "  wxWidgets Unicode?          : ${wxWidgets_USE_UNICODE}")
message(STATUS "  wxWidgets Debug?            : ${wxWidgets_USE_DEBUG}")
message(STATUS "  wxWidgets Static linking    : ${wxWidgets_USE_STATIC}")
message(STATUS "  wxWidgets version           : ${wxWidgets_VERSION}")
message(STATUS "  wxWidgets config binary     : ${wxWidgets_CONFIG_EXECUTABLE}")
message(STATUS "  wxWidgets configuration     : ${wxWidgets_CONFIGURATION}")
message(STATUS "============================================================================")

add_subdirectory(src/build)
add_subdirectory(src/images)
add_subdirectory(src/core)
add_subdirectory(src/grandorgue)
add_subdirectory(src/tools)
add_subdirectory(po)
add_subdirectory(help)
add_subdirectory(sounds)
add_subdirectory(packages)
add_subdirectory(perftests)
add_subdirectory(resources)


# packaging

# deal with possible package names among grandorgue, grandorgue-wx30, grandorgue-wx32
set(BASE_PACKAGE_NAME "grandorgue")

set(OTHER_PACKAGE_NAMES "${BASE_PACKAGE_NAME}" "${BASE_PACKAGE_NAME}-wx30" "${BASE_PACKAGE_NAME}-wx32")
set(CPACK_PACKAGE_NAME "${BASE_PACKAGE_NAME}")
if(CMAKE_PACKAGE_SUFFIX)
  set(CPACK_PACKAGE_NAME "${BASE_PACKAGE_NAME}-${CMAKE_PACKAGE_SUFFIX}")
endif()
list(REMOVE_ITEM OTHER_PACKAGE_NAMES "${CPACK_PACKAGE_NAME}")
if(NOT GO_SEPARATE_LINUX_PACKAGES)
  # For automatic removal of previously installed subpackages
  list(APPEND OTHER_PACKAGE_NAMES "${BASE_PACKAGE_NAME}-resources" "${BASE_PACKAGE_NAME}-demo")
endif()

set(CPACK_PACKAGE_VENDOR "GrandOrgue contributors")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "OpenSource Virtual Pipe Organ Software")
set(
  CPACK_PACKAGE_DESCRIPTION
  "GrandOrgue is a virtual pipe organ sample player application"
)
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_RELEASE ${BUILD_VERSION})

set(CPACK_PACKAGE_INSTALL_DIRECTORY "GrandOrgue")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/LICENSE)
set(CPACK_PACKAGE_CONTACT "osamarin68@gmail.com")
set(CPACK_PACKAGE_EXECUTABLES "GrandOrgue" "GrandOrgue")

set(CPACK_SOURCE_IGNORE_FILES "/\\\\.git/" "/build/")

# components
set(CPACK_COMPONENTS_ALL Unspecified resources demo)
set(CPACK_COMPONENT_UNSPECIFIED_DISPLAY_NAME "GrandOrgue")

set(CPACK_COMPONENT_RESOURCES_DISPLAY_NAME "GrandOrgue Resource Files")
set(
  CPACK_COMPONENT_RESOURCES_DESCRIPTION
  "This package contains the various resource files for GrandOrgue"
)

set(CPACK_COMPONENT_DEMO_DISPLAY_NAME "GrandOrgue Demo Sampleset")
set(
  CPACK_COMPONENT_DEMO_DESCRIPTION 
  "This package contains the demo sampleset for GrandOrgue"
)

set(CPACK_COMPONENT_UNSPECIFIED_HIDDEN OFF)
set(CPACK_COMPONENT_UNSPECIFIED_DEPENDS resources)
set(CPACK_COMPONENT_DEMO_DEPENDS Unspecified)

if (APPLE)
   # see the following URL for information about these variables
   # https://developer.apple.com/library/mac/#documentation/General/Reference/InfoPlistKeyReference/Articles/CoreFoundationKeys.html
   set(BUNDLE_CFBundleShortVersionString ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_STAGE})
   set(BUNDLE_CFBundleVersion ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_STAGE})

   set(CPACK_PACKAGE_ICON "${RESOURCEDIR}/GrandOrgue.icns")

   configure_file(${CMAKE_SOURCE_DIR}/src/grandorgue/resource/Info.plist.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Info.plist)
   INSTALL(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Info.plist DESTINATION "${PROJECT_NAME}.app/Contents/")

  set (CPACK_SYSTEM_NAME "osx")
  set (CPACK_GENERATOR DragNDrop)

elseif (WIN32)

  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CPACK_STRIP_FILES OFF)
  else()
    set(CPACK_STRIP_FILES ON)
  endif()

  set (CPACK_SYSTEM_NAME "windows")
  set (CPACK_GENERATOR ZIP NSIS)
  SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
    WriteRegStr HKCR \\\".organ\\\" \\\"\\\" \\\"GrandOrgue.odf\\\"
    WriteRegStr HKCR \\\".orgue\\\" \\\"\\\" \\\"GrandOrgue.package\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\" \\\"\\\" \\\"GrandOrgue organ definition file\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\\DefaultIcon\\\" \\\"\\\" \\\"$INSTDIR\\\\bin\\\\GrandOrgue.exe,0\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\\shell\\\" \\\"\\\" \\\"open\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\\shell\\\\open\\\\command\\\" \\\"\\\" '$INSTDIR\\\\bin\\\\GrandOrgue.exe \\\"%1\\\"'
    WriteRegStr HKCR \\\"GrandOrgue.package\\\" \\\"\\\" \\\"GrandOrgue organ package\\\"
    WriteRegStr HKCR \\\"GrandOrgue.package\\\\DefaultIcon\\\" \\\"\\\" \\\"$INSTDIR\\\\bin\\\\GrandOrgue.exe,0\\\"
    WriteRegStr HKCR \\\"GrandOrgue.package\\\\shell\\\" \\\"\\\" \\\"open\\\"
    WriteRegStr HKCR \\\"GrandOrgue.package\\\\shell\\\\open\\\\command\\\" \\\"\\\" '$INSTDIR\\\\bin\\\\GrandOrgue.exe \\\"%1\\\"'
  ")
  SET(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "
    ReadRegStr $R0 HKCR \\\".organ\\\" \\\"\\\"
    StrCmp $R0 \\\"GrandOrgue.odf\\\" 0 +2

=== resources/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2023 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later
# (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

set(DEPLIST)

# ========================
# Generate icons from svg
# ========================

# Find ImageMagick
find_program(ImageMagick_convert_EXECUTABLE convert)

# Setup command to generate GOIcon.ico.
# That icon is used for two purposes:
# 1. Windows application icon (included from GrandOrgue.rc that is copied below and included from ${CMAKE_SOURCE_DIR}/src/grandorgue/CMakeLists.txt)
# 2. Conversion into .cpp and usage in GO code (in ${CMAKE_SOURCE_DIR}/src/images/CMakeLists.txt)
ADD_CUSTOM_COMMAND(OUTPUT "${RESOURCEDIR}/GOIcon.ico"
                     COMMAND ${ImageMagick_convert_EXECUTABLE} -background none -resize 32x32 "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.svg" "${RESOURCEDIR}/GOIcon.ico" 
                     DEPENDS ${CMAKE_SOURCE_DIR}/resources/GrandOrgue.svg)
# Following files reference GOIcon.ico by a relative path, because of that they need to be placed near GOIcon.ico
ADD_CUSTOM_COMMAND(OUTPUT "${RESOURCEDIR}/GrandOrgue.rc"
                   COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.rc" "${RESOURCEDIR}/GrandOrgue.rc"
                   DEPENDS "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.rc")
ADD_CUSTOM_COMMAND(OUTPUT "${RESOURCEDIR}/GrandOrgue.manifest"
                   COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.manifest" "${RESOURCEDIR}/GrandOrgue.manifest"
                   DEPENDS "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.manifest")
# Without that instuctions on building files above doesn't being added to Makefile
LIST(APPEND DEPLIST "${RESOURCEDIR}/GOIcon.ico" "${RESOURCEDIR}/GrandOrgue.rc" "${RESOURCEDIR}/GrandOrgue.manifest" ${GENERATED_ICONS})

# Configure generation of icons & create directory for generated .png icons
# Directory is named GrandOrgue.iconset because iconutil (for MacOS) requires such name
# Icons from this directory will be included into linux package (with renaming) and into MacOS icons (assembled into archive via iconutil)
set(ICON_SIZES 16 32 64 128 256 512 1024)
set(GENERATED_ICONS_DIR "${RESOURCEDIR}/GrandOrgue.iconset" )
ADD_CUSTOM_COMMAND(OUTPUT ${GENERATED_ICONS_DIR} COMMAND ${CMAKE_COMMAND} -E make_directory ${GENERATED_ICONS_DIR})

# Setup commands to generate .png icons of different sizes
# GENERATED_ICONS contains paths to generated icons
set(GENERATED_ICONS)
foreach(ICON_SIZE IN ITEMS ${ICON_SIZES})
  LIST(APPEND GENERATED_ICONS "${GENERATED_ICONS_DIR}/icon_${ICON_SIZE}x${ICON_SIZE}.png" )
  ADD_CUSTOM_COMMAND(OUTPUT "${GENERATED_ICONS_DIR}/icon_${ICON_SIZE}x${ICON_SIZE}.png" 
                     COMMAND ${ImageMagick_convert_EXECUTABLE} -background none -resize ${ICON_SIZE}x${ICON_SIZE} "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.svg" "${GENERATED_ICONS_DIR}/icon_${ICON_SIZE}x${ICON_SIZE}.png"
                     DEPENDS ${CMAKE_SOURCE_DIR}/resources/GrandOrgue.svg ${GENERATED_ICONS_DIR})
endforeach()

# ========================
# Install resources
# ========================
function(add_man_page EXECUTABLE_NAME)
  ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${EXECUTABLE_NAME}.1" COMMAND ${XSLTPROC} -o "${CMAKE_CURRENT_BINARY_DIR}/" ${DOCBOOK_PATH}/manpages/docbook.xsl "${CMAKE_CURRENT_SOURCE_DIR}/${EXECUTABLE_NAME}Man.xml" DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${EXECUTABLE_NAME}Man.xml)
  LIST(APPEND DEPLIST "${CMAKE_CURRENT_BINARY_DIR}/${EXECUTABLE_NAME}.1")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${EXECUTABLE_NAME}.1" DESTINATION share/man/man1)
  set(DEPLIST ${DEPLIST} PARENT_SCOPE)
endfunction()

if (APPLE)
   ADD_CUSTOM_COMMAND(OUTPUT "${RESOURCEDIR}/GrandOrgue.icns" COMMAND iconutil -c icns ${GENERATED_ICONS_DIR} DEPENDS ${GENERATED_ICONS})
   INSTALL(FILES "${RESOURCEDIR}/GrandOrgue.icns" DESTINATION "${RESOURCEINSTDIR}")
   LIST(APPEND DEPLIST "${RESOURCEDIR}/GrandOrgue.icns" ${GENERATED_ICONS})
elseif(UNIX)
  # Install generated icons for linux 
  LIST(APPEND DEPLIST ${GENERATED_ICONS})
  foreach(ICON_SIZE IN ITEMS ${ICON_SIZES})
    INSTALL(FILES "${GENERATED_ICONS_DIR}/icon_${ICON_SIZE}x${ICON_SIZE}.png" RENAME GrandOrgue.png DESTINATION share/icons/hicolor/${ICON_SIZE}x${ICON_SIZE}/apps)
  endforeach()

  install(FILES grandorgue.xml DESTINATION share/mime/packages)

  if (GETTEXT_FOUND)
    ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} --desktop --template ${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.desktop.in -d ${CMAKE_SOURCE_DIR}/po -o "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.desktop.in)
  else()
    ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.desktop.in "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.desktop.in)
  endif()
  LIST(APPEND DEPLIST "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" DESTINATION share/applications)

  if(XSLTPROC AND DOCBOOK_PATH)
    add_man_page(GrandOrgue)
    add_man_page(GrandOrguePerfTest)
    add_man_page(GrandOrgueTool)
  else()
    MESSAGE(STATUS "Not build manpage - some programs are missing")
  endif()

  string(TIMESTAMP TODAY "%Y-%m-%d")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.appdata.xml.in" "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.appdata.xml/GrandOrgue.appdata.xml")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.appdata.xml/GrandOrgue.appdata.xml" DESTINATION share/metainfo)
endif()

message(STATUS "DEPLIST=${DEPLIST}")

ADD_CUSTOM_TARGET(resources ALL DEPENDS ${DEPLIST})

=== src/grandorgue/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2023 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include(${CMAKE_SOURCE_DIR}/cmake/AddLinkerOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/CopyWxTranslations.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/CopyDependencies.cmake)

add_option(-mmmx)
add_option(-msse)
add_option(-msse2)
add_option(-msse3)

add_option(-mstackrealign)

find_package(wxWidgets REQUIRED html net adv core base)
include(${wxWidgets_USE_FILE})
if (APPLE)
  # /usr/local/share/cmake/yaml-cpp/yaml-cpp-config.cmake sets
  # empty YAML_CPP_INCLUDE_DIR and YAML_CPP_LIBRARIES, so we use pkg_config
  pkg_check_modules(YAML_CPP REQUIRED yaml-cpp)
else()
  # but pkg_config does not support static linking for yaml-cpp, so use cmake config
  ## at first, try to find static package
  set(CMAKE_FIND_DEBUG_MODE TRUE)
  find_package(yaml-cpp REQUIRED)
  set(CMAKE_FIND_DEBUG_MODE FALSE)
  message("yaml-cpp_CONFIG=${yaml-cpp_CONFIG}")
  include("${yaml-cpp_CONFIG}")
  # the variables are different in both methods
  set(YAML_CPP_INCLUDE_DIRS "${YAML_CPP_INCLUDE_DIR}")
endif()

message("YAML_CPP_INCLUDE_DIRS=${YAML_CPP_INCLUDE_DIRS}")
message("YAML_CPP_LIBRARIES=${YAML_CPP_LIBRARIES}")

include_directories(${CMAKE_BINARY_DIR}/src/core/go_defs.h ${CMAKE_CURRENT_SOURCE_DIR}/resource ${CMAKE_SOURCE_DIR}/src/core)
include_directories(${RT_INCLUDE_DIRS})
include_directories(${PORTAUDIO_INCLUDE_DIRS})
include_directories(${ZITACONVOLVER_INCLUDE_DIRS})
include_directories(${FFTW_INCLUDE_DIRS})
include_directories(${wxWidgets_INCLUDE_DIRS})
include_directories(${JACK_INCLUDE_DIRS})
include_directories(${YAML_CPP_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(grandorgue_src
combinations/control/GOCombinationButtonSet.cpp
combinations/control/GOCombinationControllerProxy.cpp
combinations/control/GODivisionalButtonControl.cpp
combinations/control/GOGeneralButtonControl.cpp
combinations/model/GOCombination.cpp
combinations/model/GOCombinationDefinition.cpp
combinations/model/GODivisionalCombination.cpp
combinations/model/GOGeneralCombination.cpp
combinations/GODivisionalSetter.cpp
combinations/GOSetter.cpp
config/GOConfig.cpp
config/GOMidiDeviceConfig.cpp
config/GOMidiDeviceConfigList.cpp
config/GOPortsConfig.cpp
config/GOPortFactory.cpp
control/GOButtonControl.cpp
control/GOCallbackButtonControl.cpp
control/GOElementCreator.cpp
control/GOEventDistributor.cpp
control/GOLabelControl.cpp
control/GOPistonControl.cpp
dialogs/common/GODialogCloser.cpp
dialogs/common/GODialogSizeSet.cpp
dialogs/common/GODialogTab.cpp
dialogs/common/GOSimpleDialog.cpp
dialogs/common/GOTabbedDialog.cpp
dialogs/midi-event/GOMidiEventDialog.cpp
dialogs/midi-event/GOMidiEventKeyTab.cpp
dialogs/midi-event/GOMidiEventRecvTab.cpp
dialogs/midi-event/GOMidiEventSendTab.cpp
dialogs/settings/GOSettingsAudio.cpp
dialogs/settings/GOSettingsDialog.cpp
dialogs/settings/GOSettingsMidiDeviceList.cpp
dialogs/settings/GOSettingsMidiDevices.cpp
dialogs/settings/GOSettingsMidiMatchDialog.cpp
dialogs/settings/GOSettingsMidiMessage.cpp
dialogs/settings/GOSettingsPaths.cpp
dialogs/settings/GOSettingsPorts.cpp
dialogs/settings/GOSettingsOptions.cpp
dialogs/settings/GOSettingsOrgans.cpp
dialogs/settings/GOSettingsReverb.cpp
dialogs/settings/GOSettingsTemperaments.cpp
dialogs/GOMidiListDialog.cpp
dialogs/GOOrganSettingsDialog.cpp
dialogs/GOProgressDialog.cpp
dialogs/GOSelectOrganDialog.cpp
dialogs/GOSplash.cpp
document-base/GODocumentBase.cpp
document-base/GOView.cpp
gui/primitives/GOBitmap.cpp
gui/primitives/GODC.cpp
gui/primitives/GOFont.cpp
gui/primitives/go_gui_utils.cpp
gui/GOGUIBankedGeneralsPanel.cpp
gui/GOGUIButton.cpp
gui/GOGUICrescendoPanel.cpp
gui/GOGUIControl.cpp
gui/GOGUICouplerPanel.cpp
gui/GOGUIDisplayMetrics.cpp
gui/GOGUIDivisionalsPanel.cpp
gui/GOGUIEnclosure.cpp
gui/GOGUIFloatingPanel.cpp
gui/GOGUIHW1Background.cpp
gui/GOGUIHW1DisplayMetrics.cpp
gui/GOGUIImage.cpp
gui/GOGUILayoutEngine.cpp
gui/GOGUIPanelView.cpp
gui/GOGUISetterDisplayMetrics.cpp
gui/GOGUILabel.cpp
gui/GOGUIManual.cpp
gui/GOGUIManualBackground.cpp
gui/GOGUIMasterPanel.cpp
gui/GOGUIMetronomePanel.cpp
gui/GOGUIPanel.cpp
gui/GOGUIPanelWidget.cpp
gui/GOGUIRecorderPanel.cpp
gui/GOGUISequencerPanel.cpp
gui/GOGUISizeKeeper.cpp
help/GOHelpController.cpp
help/GOHelpRequestor.cpp
loader/GOFileStore.cpp
loader/GOLoaderFilename.cpp
loader/GOLoadThread.cpp
loader/GOLoadWorker.cpp
midi/dialog-creator/GOMidiDialogCreatorProxy.cpp
midi/ports/GOMidiInPort.cpp
midi/ports/GOMidiOutPort.cpp
midi/ports/GOMidiPort.cpp
midi/ports/GOMidiPortFactory.cpp
midi/ports/GOMidiRtPortFactory.cpp
midi/ports/GOMidiRtInPort.cpp
midi/ports/GOMidiRtOutPort.cpp
midi/GOMidi.cpp
midi/GOMidiConfigurator.cpp
midi/GOMidiInputMerger.cpp
midi/GOMidiListener.cpp
midi/GOMidiOutputMerger.cpp
midi/GOMidiPlayer.cpp
midi/GOMidiPlayerContent.cpp
midi/GOMidiSendProxy.cpp
midi/GOMidiSender.cpp
midi/GOMidiShortcutPattern.cpp
midi/GOMidiShortcutReceiver.cpp
midi/GOMidiReceiver.cpp
midi/GOMidiRecorder.cpp
model/pipe-config/GOPipeConfig.cpp
model/pipe-config/GOPipeConfigNode.cpp
model/pipe-config/GOPipeConfigTreeNode.cpp
model/GOCacheObject.cpp
model/GOCoupler.cpp
model/GODivisionalCoupler.cpp
model/GODrawStop.cpp
model/GODummyPipe.cpp
model/GOEnclosure.cpp
model/GOEventHandlerList.cpp
model/GOManual.cpp
model/GOOrganModel.cpp
model/GOPipe.cpp
model/GORank.cpp
model/GOReferencePipe.cpp
model/GOSoundingPipe.cpp
model/GOStop.cpp
model/GOSwitch.cpp
model/GOTremulant.cpp
model/GOWindchest.cpp
modification/GOModificationProxy.cpp
sound/ports/GOSoundJackPort.cpp
sound/ports/GOSoundPort.cpp
sound/ports/GOSoundPortFactory.cpp
sound/ports/GOSoundPortaudioPort.cpp
sound/ports/GOSoundRtPort.cpp
sound/scheduler/GOSoundGroupWorkItem.cpp
sound/scheduler/GOSoundOutputWorkItem.cpp
sound/scheduler/GOSoundReleaseWorkItem.cpp
sound/scheduler/GOSoundScheduler.cpp
sound/scheduler/GOSoundThread.cpp
sound/scheduler/GOSoundTouchWorkItem.cpp
sound/scheduler/GOSoundTremulantWorkItem.cpp
sound/scheduler/GOSoundWindchestWorkItem.cpp
sound/GOSoundAudioSection.cpp
sound/GOSoundEngine.cpp
sound/GOSoundProvider.cpp
sound/GOSoundProviderSynthedTrem.cpp
sound/GOSoundProviderWave.cpp
sound/GOSoundRecorder.cpp
sound/GOSoundReleaseAlignTable.cpp
sound/GOSoundReverb.cpp
sound/GOSoundReverbEngine.cpp
sound/GOSoundReverbPartition.cpp
sound/GOSoundResample.cpp
sound/GOSoundSamplerPool.cpp
sound/GOSoundStateHandler.cpp
sound/GOSound.cpp
yaml/GOSaveableToYaml.cpp
yaml/go-wx-yaml.cpp
GOAudioGauge.cpp
GOAudioRecorder.cpp
GOCache.cpp
GOCacheCleaner.cpp
GOCacheWriter.cpp
GOBitmapCache.cpp
GOEvent.cpp
GOLog.cpp
GOLogWindow.cpp
GOMetronome.cpp
GOMainWindowData.cpp
GOOrganController.cpp
GOProperties.cpp
GOFrame.cpp
GODocument.cpp
GOVirtualCouplerController.cpp
)

if (USE_INTERNAL_ZITACONVOLVER)
  list(APPEND grandorgue_src ${CMAKE_SOURCE_DIR}/submodules/ZitaConvolver/source/zita-convolver.cc)
endif()

add_library(golib STATIC ${grandorgue_src})
set(go_libs ${wxWidgets_LIBRARIES} ${YAML_CPP_LIBRARIES} ${RT_LIBRARIES} ${PORTAUDIO_LIBRARIES} ${FFTW_LIBRARIES} ${ZITACONVOLVER_LIBRARIES})
set(go_libdir ${wxWidgets_LIBRARY_DIRS} ${RT_LIBDIR} ${PORTAUDIO_LIBDIR} ${FFTW_LIBDIR})
target_link_libraries(golib GrandOrgueImages GrandOrgueCore ${go_libs})
link_directories(${go_libdir})

if (WIN32)
  set_source_files_properties("${RESOURCEDIR}/GrandOrgue.rc" PROPERTIES GENERATED "YES")
  add_executable(GrandOrgue WIN32 GOApp.cpp "${RESOURCEDIR}/GrandOrgue.rc")
  add_dependencies(GrandOrgue resources) # GrandOrgue.rc and GrandOrgue.manifest & GOIcon.ico referenced from GrandOrgue.rc
  add_linker_option(GrandOrgue large-address-aware)
else ()
   add_executable(GrandOrgue GOApp.cpp)
endif ()

BUILD_EXECUTABLE(GrandOrgue)
target_link_libraries(GrandOrgue golib)

if (INSTALL_DEPEND STREQUAL "ON")
  CopyWxTranslations()
  CopyDependencies(GrandOrgue "${BININSTDIR}/GrandOrgue${CMAKE_EXECUTABLE_SUFFIX}" ${go_libs} ${go_libdir})
endif()

if (GO_USE_JACK)
   add_definitions(-DGO_USE_JACK)
   target_link_libraries(golib PkgConfig::JACK)
endif ()

=== src/images/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2023 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include(${CMAKE_SOURCE_DIR}/cmake/ConvertImages.cmake)

find_package(wxWidgets REQUIRED core base)
include(${wxWidgets_USE_FILE})

set(IMAGE_LIST)
CONVERTIMAGE(IMAGE_LIST gauge.gif)
CONVERTIMAGE(IMAGE_LIST help.png)
CONVERTIMAGE(IMAGE_LIST memory.png)
CONVERTIMAGE(IMAGE_LIST panic.png)
CONVERTIMAGE(IMAGE_LIST properties.png)
CONVERTIMAGE(IMAGE_LIST reload.png)
CONVERTIMAGE(IMAGE_LIST set.png)
CONVERTIMAGE(IMAGE_LIST transpose.png)
CONVERTIMAGE(IMAGE_LIST reverb.png)
CONVERTIMAGE(IMAGE_LIST open.png)
CONVERTIMAGE(IMAGE_LIST polyphony.png)
CONVERTIMAGE(IMAGE_LIST record.png)
CONVERTIMAGE(IMAGE_LIST save.png)
CONVERTIMAGE(IMAGE_LIST settings.png)
CONVERTIMAGE(IMAGE_LIST volume.png)
CONVERTIMAGE(IMAGE_LIST Splash.jpg)
CONVERTIMAGE(IMAGE_LIST ASIO.jpg)
CONVERTIMAGE(IMAGE_LIST "${RESOURCEDIR}/GOIcon.ico")
CONVERTIMAGE(IMAGE_LIST ManualCBlackDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualCBlackUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualCWhiteDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualCWhiteUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualCWoodDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualCWoodUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualDBlackDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualDBlackUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualDWhiteDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualDWhiteUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualDWoodDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualDWoodUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualEBlackDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualEBlackUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualEWhiteDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualEWhiteUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualEWoodDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualEWoodUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalBlackDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalBlackUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWhiteDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWhiteUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWoodDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWoodUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpBlackDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpBlackUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWhiteDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWhiteUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWoodDown01.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWoodUp01.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalBlackDown01.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalBlackUp01.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalWoodDown01.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalWoodUp01.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpBlackDown01.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpBlackUp01.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpWoodDown01.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpWoodUp01.png)
CONVERTIMAGE(IMAGE_LIST ManualCBlackDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualCBlackUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualCWhiteDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualCWhiteUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualCWoodDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualCWoodUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualDBlackDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualDBlackUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualDWhiteDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualDWhiteUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualDWoodDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualDWoodUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualEBlackDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualEBlackUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualEWhiteDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualEWhiteUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualEWoodDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualEWoodUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalBlackDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalBlackUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWhiteDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWhiteUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWoodDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWoodUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpBlackDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpBlackUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWhiteDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWhiteUp02.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWoodDown02.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWoodUp02.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalBlackDown02.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalBlackUp02.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalWoodDown02.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalWoodUp02.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpBlackDown02.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpBlackUp02.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpWoodDown02.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpWoodUp02.png)
CONVERTIMAGE(IMAGE_LIST Wood01.jpg)
CONVERTIMAGE(IMAGE_LIST Wood03.jpg)
CONVERTIMAGE(IMAGE_LIST Wood05.jpg)
CONVERTIMAGE(IMAGE_LIST Wood07.jpg)
CONVERTIMAGE(IMAGE_LIST Wood09.jpg)
CONVERTIMAGE(IMAGE_LIST Wood11.jpg)
CONVERTIMAGE(IMAGE_LIST Wood13.jpg)
CONVERTIMAGE(IMAGE_LIST Wood15.jpg)
CONVERTIMAGE(IMAGE_LIST Wood17.jpg)
CONVERTIMAGE(IMAGE_LIST Wood19.jpg)
CONVERTIMAGE(IMAGE_LIST Wood21.jpg)
CONVERTIMAGE(IMAGE_LIST Wood23.jpg)
CONVERTIMAGE(IMAGE_LIST Wood25.jpg)
CONVERTIMAGE(IMAGE_LIST Wood27.jpg)
CONVERTIMAGE(IMAGE_LIST Wood29.jpg)
CONVERTIMAGE(IMAGE_LIST Wood31.jpg)
CONVERTIMAGE(IMAGE_LIST Wood33.jpg)
CONVERTIMAGE(IMAGE_LIST Wood35.jpg)
CONVERTIMAGE(IMAGE_LIST Wood37.jpg)
CONVERTIMAGE(IMAGE_LIST Wood39.jpg)
CONVERTIMAGE(IMAGE_LIST Wood41.jpg)
CONVERTIMAGE(IMAGE_LIST Wood43.jpg)
CONVERTIMAGE(IMAGE_LIST Wood45.jpg)
CONVERTIMAGE(IMAGE_LIST Wood47.jpg)
CONVERTIMAGE(IMAGE_LIST Wood49.jpg)
CONVERTIMAGE(IMAGE_LIST Wood51.jpg)
CONVERTIMAGE(IMAGE_LIST Wood53.jpg)
CONVERTIMAGE(IMAGE_LIST Wood55.jpg)
CONVERTIMAGE(IMAGE_LIST Wood57.jpg)
CONVERTIMAGE(IMAGE_LIST Wood59.jpg)
CONVERTIMAGE(IMAGE_LIST Wood61.jpg)
CONVERTIMAGE(IMAGE_LIST Wood63.jpg)
CONVERTIMAGE(IMAGE_LIST drawstop01off.png)
CONVERTIMAGE(IMAGE_LIST drawstop01on.png)
CONVERTIMAGE(IMAGE_LIST drawstop02off.png)
CONVERTIMAGE(IMAGE_LIST drawstop02on.png)
CONVERTIMAGE(IMAGE_LIST drawstop03off.png)
CONVERTIMAGE(IMAGE_LIST drawstop03on.png)
CONVERTIMAGE(IMAGE_LIST drawstop04off.png)
CONVERTIMAGE(IMAGE_LIST drawstop04on.png)
CONVERTIMAGE(IMAGE_LIST drawstop05off.png)
CONVERTIMAGE(IMAGE_LIST drawstop05on.png)
CONVERTIMAGE(IMAGE_LIST drawstop06off.png)
CONVERTIMAGE(IMAGE_LIST drawstop06on.png)
CONVERTIMAGE(IMAGE_LIST drawstop07off.png)
CONVERTIMAGE(IMAGE_LIST drawstop07on.png)
CONVERTIMAGE(IMAGE_LIST piston01off.png)
CONVERTIMAGE(IMAGE_LIST piston01on.png)
CONVERTIMAGE(IMAGE_LIST piston02off.png)
CONVERTIMAGE(IMAGE_LIST piston02on.png)
CONVERTIMAGE(IMAGE_LIST piston03off.png)
CONVERTIMAGE(IMAGE_LIST piston03on.png)
CONVERTIMAGE(IMAGE_LIST piston04off.png)
CONVERTIMAGE(IMAGE_LIST piston04on.png)
CONVERTIMAGE(IMAGE_LIST piston05off.png)
CONVERTIMAGE(IMAGE_LIST piston05on.png)
CONVERTIMAGE(IMAGE_LIST label01.png)
CONVERTIMAGE(IMAGE_LIST label02.png)
CONVERTIMAGE(IMAGE_LIST label03.png)
CONVERTIMAGE(IMAGE_LIST label04.png)
CONVERTIMAGE(IMAGE_LIST label05.png)
CONVERTIMAGE(IMAGE_LIST label06.png)
CONVERTIMAGE(IMAGE_LIST label07.png)
CONVERTIMAGE(IMAGE_LIST label08.png)
CONVERTIMAGE(IMAGE_LIST label09.png)
CONVERTIMAGE(IMAGE_LIST label10.png)
CONVERTIMAGE(IMAGE_LIST label11.png)
CONVERTIMAGE(IMAGE_LIST label12.png)
CONVERTIMAGE(IMAGE_LIST label13.png)
CONVERTIMAGE(IMAGE_LIST label14.png)
CONVERTIMAGE(IMAGE_LIST label15.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA00.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA01.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA02.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA03.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA04.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA05.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA06.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA07.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA08.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA09.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA10.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA11.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA13.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA14.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA15.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB00.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB01.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB02.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB03.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB04.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB05.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB06.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB07.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB08.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB09.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB10.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB11.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB13.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB14.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB15.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC00.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC01.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC02.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC03.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC04.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC05.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC06.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC07.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC08.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC09.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC10.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC11.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC13.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC14.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC15.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD00.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD01.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD02.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD03.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD04.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD05.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD06.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD07.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD08.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD09.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD10.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD11.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD13.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD14.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD15.png)

BUILD_LIBRARY(GrandOrgueImages ${IMAGE_LIST})
add_dependencies(GrandOrgueImages resources) # Build GOIcon.ico before generating .cpp from images
target_link_libraries(GrandOrgueImages ${wxWidgets_LIBRARIES})
link_directories(${wxWidgets_LIBRARY_DIRS})

=== src/tools/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2023 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

add_option(-mmmx)
add_option(-msse)
add_option(-msse2)
add_option(-msse3)

add_option(-mstackrealign)

include(UsewxWidgets)

include_directories(${CMAKE_BINARY_DIR}/src/core/go_defs.h ${CMAKE_SOURCE_DIR}/src/core)

if (WIN32)
   set_source_files_properties("${RESOURCEDIR}/GrandOrgue.rc" PROPERTIES GENERATED "YES")
   add_executable(GrandOrgueTool GOTool.cpp "${RESOURCEDIR}/GrandOrgue.rc")
   add_dependencies(GrandOrgueTool resources) # GrandOrgue.rc and GrandOrgue.manifest & GOIcon.ico referenced from GrandOrgue.rc
   add_linker_option(GrandOrgueTool large-address-aware)
else ()
   add_executable(GrandOrgueTool GOTool.cpp)
endif ()

BUILD_EXECUTABLE(GrandOrgueTool)
target_link_libraries(GrandOrgueTool GrandOrgueCore)

add_executable(GrandOrguePerfTest GOPerfTest.cpp)
BUILD_EXECUTABLE(GrandOrguePerfTest)
target_include_directories(GrandOrguePerfTest PUBLIC ${CMAKE_SOURCE_DIR}/src/grandorgue)
target_link_libraries(GrandOrguePerfTest golib)

add_custom_target(runperftest COMMAND GrandOrguePerfTest "${CMAKE_SOURCE_DIR}/tests" DEPENDS GrandOrguePerfTest)

=== src/rt/rtaudio/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2023 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

message(STATUS "RtAudio build Configuration")

INCLUDE (CheckIncludeFileCXX)

include_directories("${RTAUDIO_SRC_DIR}/include")
set(RtAudio_Sources "${RTAUDIO_SRC_DIR}/RtAudio.cpp")

if (WIN32)
  if (RTAUDIO_USE_ASIO)
    set(RtAudio_Sources ${RtAudio_Sources}
      "${ASIO_SDK_DIR}/host/asiodrivers.cpp"
      "${ASIO_SDK_DIR}/host/pc/asiolist.cpp"
      "${ASIO_SDK_DIR}/common/asio.cpp"
      "${RTAUDIO_SRC_DIR}/include/iasiothiscallresolver.cpp"
    )
  endif ()
endif ()

add_library(RtAudio STATIC ${RtAudio_Sources})

if (WIN32)

   message(STATUS "  Building a Windows configuration")
   message(STATUS "    Support for DirectSound   : ${RTAUDIO_USE_DSOUND}")
   message(STATUS "    Support for Asio          : ${RTAUDIO_USE_ASIO}")

   if (RTAUDIO_USE_DSOUND)
      add_definitions(-D__WINDOWS_DS__)
      target_link_libraries(RtAudio dsound)
   endif ()

   if (RTAUDIO_USE_ASIO)
      add_definitions(-D__WINDOWS_ASIO__ -D_WIN32_WINNT=0x0501 -DWINVER=0x0501)
      include_directories(
	"${ASIO_SDK_DIR}/common"
        "${ASIO_SDK_DIR}/host"
	"${ASIO_SDK_DIR}/host/pc"
      )
      include_directories(asiohelpers)
      include_directories(asiohelpers/include)
   endif ()

elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

   message(STATUS "  Building a Linux configuration")
   message(STATUS "    Support for Jack          : ${RTAUDIO_USE_JACK}")
   message(STATUS "    Support for Alsa          : ${RTAUDIO_USE_ALSA}")
   message(STATUS "    Support for OSS           : ${RTAUDIO_USE_OSS}")

   if (RTAUDIO_USE_JACK)
      add_definitions(-D__UNIX_JACK__)
      target_link_libraries(RtAudio PkgConfig::JACK)
   endif ()

   if (RTAUDIO_USE_ALSA)
      add_definitions(-D__LINUX_ALSA__)
      target_link_libraries(RtAudio asound)
   endif ()

   if (RTAUDIO_USE_OSS)
      add_definitions(-D__LINUX_OSS__)
      target_link_libraries(RtAudio aoss)
   endif ()

   target_link_libraries(RtAudio pthread)

elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

   message(STATUS "  Building a Mac configuration")
   message(STATUS "    Support for Jack          : ${RTAUDIO_USE_JACK}")
   message(STATUS "    Support for CoreAudio     : ${RTAUDIO_USE_CORE}")

   if (RTAUDIO_USE_JACK)
      add_definitions(-D__UNIX_JACK__)
      target_link_libraries(RtAudio PkgConfig::JACK)
   endif ()

   if (RTAUDIO_USE_CORE)
      add_definitions(-D__MACOSX_CORE__)
      target_link_libraries(RtAudio -framework\ CoreAudio -framework\ CoreFoundation)
   endif ()

else ()

   message(FATAL_ERROR "  Unknown/unsupported build configuration")

endif ()

message(STATUS "============================================================================")

=== debian/changelog ===
grandorgue (3.13.1-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:54:25 +1100

grandorgue (3.13.1-1build1) noble; urgency=high

  * No change rebuild against libwxbase3.2-1t64, libwxgtk3.2-1t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:16:52 +0100

grandorgue (3.13.1-1) unstable; urgency=medium

  * New upstream version 3.13.1

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 09 Nov 2023 08:34:17 +0100

=== debian/control ===
Source: grandorgue
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sébastien Villemot <sebastien@debian.org>
Section: sound
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libjack-dev,
               librtaudio-dev,
               librtmidi-dev,
               portaudio19-dev,
               libfftw3-dev,
               zlib1g-dev,
               libwavpack-dev,
               libwxgtk3.2-dev,
               libzita-convolver-dev,
               libyaml-cpp-dev,
               imagemagick,
               librsvg2-bin,
               gettext,
               xsltproc,
               docbook-xsl,
               zip,
               po4a
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/grandorgue
Vcs-Git: https://salsa.debian.org/debian/grandorgue.git
Homepage: https://github.com/GrandOrgue/grandorgue
Rules-Requires-Root: no

Package: grandorgue
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: grandorgue-demo
Description: sample-based pipe organ simulator
 GrandOrgue allows the user to load and play virtual pipe organs.
 Using sample sets, GrandOrgue is able to combine the individual pipe
 sounds and organ behaviors to simulate a variety of pipe organs.
 .
 When connected to MIDI keyboards and an audio system, it can accurately
 simulate the sound of a real pipe organ.
 .
 The user can create and load organ samplesets using a dedicated file format. A
 demonstration organ sampleset is provided in the grandorgue-demo package.

Package: grandorgue-demo
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Enhances: grandorgue
Description: sample-based pipe organ simulator (demo sampleset)
 GrandOrgue allows the user to load and play virtual pipe organs.
 Using sample sets, GrandOrgue is able to combine the individual pipe
 sounds and organ behaviors to simulate a variety of pipe organs.
 .
 This package contains a demonstration organ sampleset.

## grandorgue 3.14.1

=== debian/changelog ===
grandorgue (3.14.1-1) experimental; urgency=medium

  * New upstream version 3.14.1
  * Bump S-V to 4.7.0

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 26 Apr 2024 21:12:36 +0200

grandorgue (3.14.0-2) experimental; urgency=medium

  * Add missing Build-Depends on libcurl4-openssl-dev

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 06 Apr 2024 18:35:25 +0200

grandorgue (3.14.0-1) experimental; urgency=medium

  * New upstream version 3.14.0

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 31 Mar 2024 19:00:46 +0200

grandorgue (3.13.3-1) experimental; urgency=medium

  * New upstream version 3.13.3
  * d/copyright: reflect upstream changes

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 13 Jan 2024 10:31:02 +0100

grandorgue (3.13.2-2) experimental; urgency=medium

  * Build-depend on imagemagick-6.q16 instead of imagemagick.
    The alternative implementation graphicsmagick-imagemagick-compat, which also
    provides imagemagick and can be picked by the autobuilders, fails at
    converting the SVG into an icon.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 26 Dec 2023 19:20:20 +0100

grandorgue (3.13.2-1) experimental; urgency=medium

  * New upstream version 3.13.2
    This new release is compatible with RtAudio 6. (Closes: #1051559)
  * Add version restriction to Build-Depends on librtaudio-dev (>= 6)
    This new release no longer builds against RtAudio 5.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 22 Nov 2023 21:53:51 +0100
